codeforces672D(经典二分)

 Robin Hood
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

Examples
input
4 1
1 1 4 2
output
2
input
3 1
2 2 2
output
0
题解:题目大意:有富人和穷人,最富的人每天给最穷的人一个金币,问k天后最富的人和最穷的人金币差是多少?

         我的思路:可以试一下暴力,但是应该不会过,我是先求出穷人和富人的上下界,即他们金币的总和除以人数,能除尽的话,那么富人的金币下限就是sum/n,穷人的上限就是sum/n,除不尽的话就是富人sum/n+1, 穷人sum/n。然后分别对穷人的区间和富人的区间进行二分,并求出当富人最多有x金币,穷人最少有y金币时需要多少天,如果天数大于给的天数,那么富人就肯定比x金币多,穷人比y金币少,然后一只二分求天数,最后得到结果。

下面是代码:

#include<cstdio>
#include<cstring>
#include<cmath>
#include<string>
#include<climits>
#include<vector>
#include<iostream>
#include<algorithm>
#include<queue>
#include<map>
#define ll long long
using namespace std;
int a[500005], n, k;
int check_min(int x)  //检查贫穷的人
{
    ll sum = 0;
    for(int i = 0; i < n; i++)
    {
        if(a[i]>x) break;
        sum += x-a[i];
    }
    if(sum > k) return 0;
    else return 1;
}
int check_max(int x)  // 检查富有的人
{
    ll sum = 0;
    for(int i = n-1; i>=0; i--)
    {
        if(a[i] < x) break;
        sum += a[i]-x;
    }
    if(sum>k) return 0;
    else return 1;
}
int main()
{
    
    while(~scanf("%d%d", &n, &k))
    {
        ll sum = 0;
        for(int i = 0 ;i < n; i++)
        {
            scanf("%d", a+i);
            sum += a[i];
        }
        sort(a, a+n);
        int al, ar;
        if(sum%n==0) // 判断穷人和富人的上下界
            al = sum/n, ar = sum/n; 
        else
            al = sum/n, ar = sum/n+1;
            int l = a[0], r = al;
            int ansl = a[0], ansr = a[0];
            while(r>=l)
            {
                int mid=(r+l)>>1;
                if(check_min(mid))
                {
                    ansl = mid;
                    l = mid+1;
                }
                else r = mid-1;
            }
            l = ar, r = a[n-1];
            while(r>=l)
            {
                int mid=(r+l)>>1;
                if(check_max(mid))
                {
                    ansr = mid;
                    r = mid-1;
                }
                else l = mid+1;
            }
            printf("%d\n", ansr-ansl);
    }
    return 0;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值